#line 1 "C:/Users/Mikroe/Documents/Stefan_T/MikroE/Projekti/Breakout/Breakout_c.c"
#line 1 "c:/users/mikroe/documents/stefan_t/mikroe/projekti/breakout/breakout_h.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdio.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 57 "c:/users/mikroe/documents/stefan_t/mikroe/projekti/breakout/breakout_h.h"
typedef struct
{
 uint16_t x;
 uint16_t y;
 uint16_t color;

} demo_object_t;


typedef struct
{
 uint16_t x;
 uint16_t y;
 uint8_t direction;

} demo_ball_t;



void demo_generateWall( demo_object_t *wall );
void demo_reset( demo_ball_t *ball, demo_object_t *paddle );
void demo_moveBall( demo_ball_t *ball );
void demo_collisionCheck( demo_ball_t *ball, demo_object_t *wall, demo_object_t *paddle );
#line 7 "C:/Users/Mikroe/Documents/Stefan_T/MikroE/Projekti/Breakout/Breakout_c.c"
static void drv_writePixel( uint16_t x, uint16_t y, uint16_t color )
{
 matrixrgb_writePixel( x, y, color );
 Delay_ms( 100 );
}

static void drv_paintObject( demo_object_t object, uint8_t width, uint8_t height )
{
 uint16_t y;
 uint16_t x;

 for( y = object.y; y < object.y + height; y++ )
 {
 for( x = object.x; x < object.x + width; x++ )
 {
 drv_writePixel( x, y, object.color );
 }
 }
}

static void drv_reposition( demo_ball_t *ball )
{
 switch( ball->direction )
 {
 case 0:
 ball->y -= 1;
 break;
 case 1:
 ball->x += 1;
 ball->y -= 1;
 break;
 case 2:
 ball->x += 1;
 break;
 case 3:
 ball->x += 1;
 ball->y += 1;
 break;
 case 4:
 ball->y += 1;
 break;
 case 5:
 ball->x -= 1;
 ball->y += 1;
 break;
 case 6:
 ball->x -= 1;
 break;
 case 7:
 ball->x -= 1;
 ball->y -= 1;
 }
}

static uint8_t drv_checkColumns( demo_object_t *wall, uint8_t start, uint8_t end, uint8_t y )
{
 uint8_t mid;

 if( end >= start )
 {
 mid = start + ( end - start ) / 2;

 if( wall[ mid ].y <= y && wall[ mid ].y +  2  >= y )
 return mid;

 if( wall[ mid ].y > y )
 return drv_checkColumns( wall, start, mid - 1, y );

 return drv_checkColumns( wall, mid + 1, end, y );
 }

 return  8  * 6 ;
}

static uint8_t drv_checkRows( demo_object_t *wall, uint8_t index, uint8_t x )
{
 while( 1 )
 {
 if( x >= wall[ index ].x )
 {
 if( x <= ( wall[ index ].x +  4  ) )
 {

 return index;
 }
 else
 index++;
 }
 else
 index--;
 }
}

uint8_t drv_brickCheck( demo_ball_t *ball, demo_object_t *wall )
{
 uint8_t index;

 index = drv_checkColumns( wall, 0,  8  * 6 , ball->y );

 if( index !=  8  * 6  )
 {
 index = drv_checkRows( wall, index, ball->x );



 return ball->direction;
 }
 return 0;
}





void demo_generateWall( demo_object_t *wall )
{
 uint16_t x;
 uint16_t y;
 uint8_t cnt;
 uint16_t color;

 cnt = 0;
 color = 0x0000;

 for( y = 0; y <  6 ; y++ )
 {
 for( x = 0; x <  8 ; x++ )
 {
 switch( ( y + 1 ) % 3 )
 {
 case 1:
 color =  0xF800 ;
 break;
 case 2:
 color =  0x07E0 ;
 break;
 case 0:
 color =  0x001F ;
 }

 wall[ cnt ].x = x *  4 ;
 wall[ cnt ].y = y *  2 ;
 wall[ cnt++ ].color = color;
 }
 }
}

void demo_reset( demo_ball_t *ball, demo_object_t *paddle )
{

 drv_writePixel( ball->x, ball->y,  0x0000  );

 ball->x =  0x0010 ;
 ball->y =  0x001C ;
 ball->direction =  0 ;

 drv_writePixel(  0x0010 ,  0x001C ,  0xFFFF  );


 paddle->color =  0x0000 ;
 drv_paintObject( ( *paddle ),  6 ,  1  );

 paddle->x =  0x000D ;
 paddle->y =  0x001F ;
 paddle->color =  0xF800 ;

 drv_paintObject( ( *paddle ),  6 ,  1  );
}

void demo_moveBall( demo_ball_t *ball )
{
 drv_reposition( ball );
 drv_writePixel( ball->x, ball->y,  0xFFFF  );
}
