Hardware requirements:
- Fusion for ARM v8 development board
- MCU CARD for STM32 STM32F407ZG
- Switching power supply: 
        input:  100 - 240V AC (1.3A)
        output: +5V (10A) 
- 32x32 RGB LED Matrix Panel - 6mm pitch
- Matrix RGB click
- mikroBUS Shuttle
- Shuttle click
- Slider 2 click

Software requirements:
- Mikro C PRO for ARM ( or CodeGrip Suite )

Hardware settings:
- Plug in the switching power supply and connect it with LED Matrix Panel, 
strictly observing the arrangement of the VCC and GND wires.
- Using IDC cable connect LED Matrix Panel with Matrix RGB Click,
then place Matrix RGB Click in the fifth slot on Fusion for ARM Board.
- Connect Slider 2 Click using Shuttle Click and mikroBUS Shuttle add-on, 
to the first slot on the board.


Software settings:
- Open MikroC PRO for ARM program, and first it is necessary to instal packages for Matrix RGB click 
and Slider 2 click from Libstock ( using Libstock manager ). When searching path for those packages 
are included, build and program the code. 
- Instead of that you can just write down the hex file using CodeGrip Suite.
- Injoy the game :)


Game description:

- Breakout is an arcade game developed and published on May 13, 1976.

- In Breakout, a layer of bricks lines the top third of the screen and the goal is to destroy 
them all. A ball moves straight around the screen, bouncing off the top and two sides of 
the screen. When a brick is hit, the ball bounces back and the brick is destroyed. The player 
loses a turn when the ball touches the bottom of the screen; to prevent this from happening, 
the player has a horizontally movable paddle to bounce the ball upward, keeping it in play.

- Breakout begins with six rows of bricks in a different color ( red, green, blue ). 
Using a single ball, the player must knock down as many bricks as possible by using the walls 
and/or the paddle below to ricochet the ball against the bricks and eliminate them. 
If the player's paddle misses the ball's rebound, they will lose a turn. The player has three 
turns to try to clear two screens of bricks. 